#include <stdio.h>
#include <rpc/rpc.h>
#include "rusers.h"

results *
rusers_1(filler)
int *filler;
{
   static results results;
   personinfo    *currp;
   personinfo   **currpp;
   FILE *fp;
   char buf[BUFSIZ];

   /*
    *  Free the space we allocated the previous time this
    *  procedure was called.
    */

   xdr_free(xdr_results, &results);
   
   /*
    *  Get the users currently logged on by calling
    *  the popen function
    */

   if ((fp = popen("who | cut -d' ' -f1", "r")) == NULL) {
        results.status = 1;
        results.results_u.reason = CANT_GET_INFO;
        return (&results);
   }
     
   currpp = &results.results_u.personinfop;

   while (fgets(buf, BUFSIZ, fp) != NULL) {
      if ((currp = *currpp =
         (personinfo *)malloc(sizeof(personinfo))) == NULL){
           results.status = 1;
           results.results_u.reason = NO_MEMORY;
           return (&results);
      }
      if (strlen(buf) > MAX_NAME_SIZE) {
           buf[MAX_NAME_SIZE - 1] = '\0';
      } else {
           /*
            *  Get rid of new-line character
            */
           buf[strlen(buf) - 1] = '\0';
      }
      currp->login_name = (char *)malloc(strlen(buf));
      strcpy(currp->login_name, buf);
      currpp = &(currp->nextp);
   }
   *currpp = NULL;
   results.status = 0;
   return &results;
}
